#!/usr/bin/sh
#set -x
#
#
# check_mem.sh
#
## Description:
#	Check HP-UX device memory or swap. Necessary mem script.
#
## Author:
#       Cristiano Strehl (cristiano.strehl@opservices.com.br)
#
## Version:
#       1.0 26-05-2012 : Created
#

ITEM=$1
WARN=$2
CRIT=$3

case $ITEM in

	memory)

		TOTAL_MEM=$(/opt/nrpe/libexec/opservices/mem |grep physical |awk '{print $2}')
		USED_MEM=$(/opt/nrpe/libexec/opservices/mem |grep physical |awk '{print $3}')
		FREE_MEM=$(/opt/nrpe/libexec/opservices/mem |grep physical |awk '{print $4}')

		USED_MEM_POR=$(/opt/nrpe/libexec/opservices/mem |grep physical | awk '{print $5}' |cut -d'%' -f1)
		FREE_MEM_POR=$(expr 100 - $USED_MEM_POR)

		if [ $USED_MEM_POR -ge $CRIT ]; then
			echo "CRITICAL - Used memory: $USED_MEM Mb / $USED_MEM_POR% - Free: $FREE_MEM Mb / $FREE_MEM_POR% - Total: $TOTAL_MEM Mb | used_mem=$USED_MEM_POR%;$WARN;$CRIT;0;100"
			exit 2
		else
			if [ $USED_MEM_POR -ge $WARN ]; then
		       		echo "WARNING - Used memory: $USED_MEM Mb / $USED_MEM_POR% - Free: $FREE_MEM Mb / $FREE_MEM_POR% -  Total: $TOTAL_MEM Mb | used_mem=$USED_MEM_POR%;$WARN;$CRIT;0;100"
				exit 1
			else
				echo "OK - Used memory: $USED_MEM Mb / $USED_MEM_POR% - Free: $FREE_MEM Mb / $FREE_MEM_POR% -  Total: $TOTAL_MEM Mb | used_mem=$USED_MEM_POR%;$WARN;$CRIT;0;100"
               			exit 0
			fi
		fi
	;;

	swap)

                TOTAL_SWAP=$(/opt/nrpe/libexec/opservices/mem |grep "device swap" |awk '{print $3}')
                USED_SWAP=$(/opt/nrpe/libexec/opservices/mem |grep "device swap" |awk '{print $4}')
                FREE_SWAP=$(/opt/nrpe/libexec/opservices/mem |grep "device swap" |awk '{print $5}')

                USED_SWAP_POR=$(/opt/nrpe/libexec/opservices/mem |grep "device swap" | awk '{print $6}' |cut -d'%' -f1)
                FREE_SWAP_POR=$(expr 100 - $USED_SWAP_POR)

                if [ $USED_SWAP_POR -ge $CRIT ]; then
                        echo "CRITICAL - Used swap: $USED_SWAP Mb / $USED_SWAP_POR% - Free: $FREE_SWAP Mb / $FREE_SWAP_POR% - Total: $TOTAL_SWAP Mb | used_swap=$USED_SWAP_POR%;$WARN;$CRIT;0;100"
                        exit 2
                else
                        if [ $USED_SWAP_POR -ge $WARN ]; then
                                echo "WARNING - Used swap: $USED_SWAP Mb / $USED_SWAP_POR% - Free: $FREE_SWAP Mb / $FREE_SWAP_POR% -  Total: $TOTAL_SWAP Mb | used_swap=$USED_SWAP_POR%;$WARN;$CRIT;0;100"
                                exit 1
                        else
                                echo "OK - Used swap: $USED_SWAP Mb / $USED_SWAP_POR% - Free: $FREE_SWAP Mb / $FREE_SWAP_POR% -  Total: $TOTAL_SWAP Mb | used_swap=$USED_SWAP_POR%;$WARN;$CRIT;0;100"
                                exit 0
                        fi
                fi
	;;

	*)
        	echo "Usage: check_memory.sh <memory or swap> <warning> <critical>"
        	exit 1
	;;
esac
