#!/bin/sh
#set -x
#
#
# check_procs.sh
#
## Description:
#       Check HP-UX process status.
#
## Author:
#       Cristiano Strehl (cristiano.strehl@opservices.com.br)
#
## Version:
#       1.0 12-06-2012 : Created
#

OPTION=$1
PROC=$2

case $OPTION in

        -a)

                CHECK_PROC_A=$(ps -ef | grep $PROC |grep -v grep |grep -v check_procs.sh |wc -l)

                if [ $CHECK_PROC_A -lt 1 ]; then
                        echo "PROCS CRITICAL: $CHECK_PROC_A process with args '$PROC'"
                        exit 2
                else
                        echo "PROCS OK: $CHECK_PROC_A processes with args '$PROC'"
                        exit 0
                fi
        ;;

        *)
                echo "Usage: check_procs.sh -a <process args>"
                echo
                echo "-h"
                echo "Print detailed help screen"
                echo "-a"
                echo "Only scan for processes with args that contain STRING."
                echo
                echo "Example:"
                echo "check_procs.sh -a ssh"
                echo "check_procs.sh -C sshd"

                exit 1
        ;;
esac
